SETUID(2)

NAME
setuid - set user identity

SYNOPSIS
#include <unistd.h>

int setuid(uid_t uid)

DESCRIPTION
setuid sets the effective user ID of the current process. If the caller is the superuser, the real and saved user ID's are also set. Under Linux, setuid is implemented like SYSV with SAVED_IDS. This allows a setuid (other than root) program to drop all of it's user privileges, do some un-privileged work, and then re-engage the original effective user ID in a secure manner. If the user is root or the program is setuid root, special care must be taken. The setuid function checks the effective uid of the caller and if it is the superuser, all process related user ID's are set to uid. After this has occurred, it is impossible for the program to regain root privileges.

RETURN VALUE
On success, zero is returned. On error, -1 is returned, and errno is set appropriately.

ERRORS

EPERM
    The user is not the super-user, and uid does not match the effective or saved user ID of the calling process.

CONFORMING TO
System V

SEE ALSO
getuid(2), setreuid(2), seteuid(2)